routes/web.php
<?php

Route::get('/', 'ProductController@index')->name('/');

Route::resource('products', 'ProductController');

Route::get('users/login', 'UserController@login')->name('users.login');
Route::post('users/postLogin', 'UserController@postLogin')->name('users.postLogin');

Route::get('users/register', 'UserController@register')->name('users.register');
Route::post('users/postRegister', 'UserController@postRegister')->name('users.postRegister');

Route::get('users/logout', 'UserController@logout')->name('users.logout');

Route::post('feedbacks/create', 'FeedbackController@create')->name('feedbacks.create');

app/Product.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Product extends Model
{
    use SoftDeletes;

    protected $dates = ['deleted_at'];

    protected $fillable = [
        'name', 'description', 'image_name', 'author_id'
    ];

    public function categories()
    {
        return $this->belongsToMany(Category::class, 'product_categories');
    }

    public function author()
    {
        return $this->belongsTo(User::class, 'author_id', 'id');
    }

    public function feedbacks()
    {
        return $this->hasMany(Feedback::class);
    }
}

app/Http/Controllers/API/ProductController.php
<?php

namespace App\Http\Controllers\API;

use App\Category;
use App\Http\Controllers\Controller;
use App\Product;
use App\Role;
use App\User;
use Illuminate\Http\Request;
use Validator;

class ProductController extends Controller
{
    public function __construct()
    {
        $this->middleware(['auth:api', 'role:' . Role::adminRoleSlug], ['except' => [
            'index',
            'show',
            'categories'
        ]]);
    }

    public function index()
    {
        $products = Product::select(
            'products.*',
            'users.login as author_name'
        )
            ->join('users', 'products.author_id', '=', 'users.id')
            ->leftJoin('product_categories', 'products.id', '=', 'product_categories.product_id')
            ->leftJoin('categories', 'product_categories.category_id', '=', 'categories.id')
            ->leftJoin('feedbacks', 'products.id', '=', 'feedbacks.product_id')
            ->selectRaw('count(DISTINCT feedbacks.id) as feedbacks_count, AVG(feedbacks.mark) as average_mark')
            ->groupBy('products.id')
            ->selectRaw('GROUP_CONCAT(DISTINCT categories.id  separator \',\') as categories_ids')
            ->get();

        return BaseController::sendResponse(
            $products,
            'Products in data.',
            'Product information received!',
            200
        );
    }

    public function create(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'name' => 'string|required|max:255',
            'description' => 'string|required|max:1000',
            'image' => 'required|max:1000|mimes:jpeg,jpg,png',
            'categories_ids' => 'array|required',
            'categories_ids.*' => 'integer|required|distinct|exists:categories,id'
        ]);

        if ($validator->fails()) {
            return BaseController::sendError(
                $validator->errors(),
                'Errors in data.',
                'New product did not pass verification!',
                400
            );
        }

        $image_name = uniqid() . "." . $request->file('image')->extension();
        $request->file('image')->storePubliclyAs("public", $image_name);

        $product = new Product([
            'name' => $request->input('name'),
            'description' => $request->input('description'),
            'image_name' => $image_name,
            'author_id' => auth()->id()
        ]);
        $product->save();

        foreach ($request->input('categories_ids') as $category_id) {
            $product->categories()->attach($category_id);
        }

        return BaseController::sendResponse(
            $product,
            'Product created.',
            'Product added!',
            201
        );
    }

    public function show($id)
    {
        $product = Product::findOrFail($id);
        $product->author_name = $product->author->login;
        $product->categories = $product->categories()->get();
        $product->feedbacks = $product->feedbacks()->get();
        return BaseController::sendResponse(
            $product,
            'Product information in data.',
            'Product information loaded!',
            200
        );
    }

    public function update(Request $request, $id)
    {
        $validator = Validator::make($request->all(), [
            'name' => 'string|max:255',
            'description' => 'string|max:1000',
            'image' => 'max:1000|mimes:jpeg,jpg,png',
            'categories_ids.*' => 'array|distinct|exists:categories,id'
        ]);

        if ($validator->fails()) {
            return BaseController::sendError(
                $validator->errors(),
                'Errors in data.',
                'Update product did not pass verification!',
                400
            );
        }

        $product = Product::findOrFail($id);
        if ($request->exists('name')) {
            $product->name = $request->input('name');
        }
        if ($request->exists('description')) {
            $product->description = $request->input('description');
        }
        $product->save();

        $new_categories_ids = $request->input('categories_ids');
        if ($request->exists('categories_ids') && count($new_categories_ids) !== 0) {
            foreach ($product->categories as $category) {
                if (in_array($category->id, $new_categories_ids) === false) {
                    $product->categories()->detach($category->id);
                }
            }
            foreach ($new_categories_ids as $category_id) {
                if (is_null($product->categories->find($category_id))) {
                    $product->categories()->attach($category_id);
                }
            }
        }

        if ($request->exists('image')) {
            $request->file('image')->storePubliclyAs("public", $product->image_name);
        }

        return BaseController::sendResponse(
            null,
            'Product updated.',
            'Product information updated!',
            201
        );
    }

    public function destroy($id)
    {
        $product = Product::findOrFail($id);

        $product->delete();
        unlink(storage_path("app/public/{$product->image_name}"));

        return BaseController::sendResponse(
            null,
            'Delete product.',
            'Product deleted!',
            200
        );
    }

    public function categories()
    {
        return BaseController::sendResponse(
            Category::all(),
            'Categories in data.',
            'Categories list loaded!',
            200
        );
    }
}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Role;
use DB;
use Illuminate\Http\Request;
use App\Product;
use App\Category;
use App\User;

class ProductController extends Controller
{
    public function __construct()
    {
        $this->middleware('role:' . Role::adminRoleSlug, ['except' => [
            'index',
            'show',
        ]]);;
    }

    public function index(Request $request)
    {
        $request->validate([
            'sortBy' => 'string',
            'category_id' => 'int'
        ]);

        $products = Product::select(
            'products.*',
            'users.login as author_name'
        )
            ->join('users', 'products.author_id', '=', 'users.id')
            ->leftJoin('product_categories', 'products.id', '=', 'product_categories.product_id')
            ->leftJoin('feedbacks', 'products.id', '=', 'feedbacks.product_id')
            ->selectRaw('count(DISTINCT feedbacks.id) as feedbacks_count, AVG(feedbacks.mark) as average_mark')
            ->groupBy('products.id');

        $filterByCategoryId = $request->input('category_id', 0);
        if ($filterByCategoryId !== 0) {
            $products = $products->where('product_categories.category_id', '=', $filterByCategoryId);
        }

        $sortBy = $request->input('sortBy', 'id');
        $products = $products->orderBy($sortBy, 'DESC');

        // 6 - наиболее воспринимаемое количество, больше выглядит громоздко
        return view('products.index')->with('products', $products->paginate(6));
    }

    public function create()
    {
        return view('products.create');
    }

    public function store(Request $request)
    {
        $request->validate([
            'name' => 'string|required|max:255',
            'description' => 'string|required|max:1000',
            'image' => 'required|max:1000|mimes:jpeg,jpg,png',
            'categories_ids' => 'array|required|distinct'
        ]);

        $image_name = uniqid() . "." . $request->file('image')->extension();
        $request->file('image')->storePubliclyAs('public', $image_name);

        $product = new Product([
            'name' => $request->input('name'),
            'description' => $request->input('description'),
            'image_name' => $image_name,
            'author_id' => auth()->id()
        ]);
        $product->save();

        foreach ($request->input('categories_ids') as $category_id) {
            $product->categories()->attach($category_id);
        }

        return redirect('/products')->with('success', 'Product added!');
    }

    public function show($id)
    {
        $product = Product::findOrFail($id);
        return view('products.show', compact('product'));
    }

    public function edit($id)
    {
        $product = Product::findOrFail($id);
        return view('products.edit', compact('product'));
    }

    public function update(Request $request, $id)
    {
        $request->validate([
            'name' => 'string|required|max:255',
            'description' => 'string|required|max:1000',
            'image' => 'max:1000|mimes:jpeg,jpg,png',
            'categories_ids' => 'array|distinct'
        ]);

        $product = Product::findOrFail($id);
        $product->name = $request->input('name');
        $product->description = $request->input('description');
        $product->save();

        $new_categories_ids = $request->input('categories_ids');
        if ($request->exists('categories_ids') && count($new_categories_ids) !== 0) {
            foreach ($product->categories as $category) {
                if (in_array($category->id, $new_categories_ids) === false) {
                    $product->categories()->detach($category->id);
                }
            }
            foreach ($new_categories_ids as $category_id) {
                if (is_null($product->categories->find($category_id))) {
                    $product->categories()->attach($category_id);
                }
            }
        }

        if ($request->exists('image')) {
            $request->file('image')->storePubliclyAs("public", $product->image_name);
        }

        return redirect('/products')->with('success', 'Product updated!');
    }

    public function destroy($id)
    {
        $product = Product::findOrFail($id);

        $product->delete();
        unlink(storage_path("app/public/{$product->image_name}"));

        return redirect('/products')->with('success', 'Product deleted!');
    }
}

resources/views/products/create.blade.php
@extends('layout')
@section('title', 'New product')
@section('content')
    <h1>New product</h1>
    <div class="row">
        <form method="post" enctype="multipart/form-data" action="{{ route('products.store') }}">
            @csrf
            <div>
                <label for="name">Name:</label>
                <input maxlength=255 required="required" type="text" name="name"/>
            </div>
            <div>
                <label for="image">Image:</label>
                <input required="required" type="file" name="image"/>
            </div>
            <div>
                <label for="description">Description:</label></br>
                <textarea maxlength=1000 cols=60 rows=13 required="required" type="text" name="description"></textarea>
            </div>
            <div>
                <label for="categories_ids">Categories:</label></br>
                <select multiple name="categories_ids[]">
                    <?php
                    use App\Category;
                    $categories = Category::all();
                    $categories->map(function ($category) {
                        echo "<option value=\"{$category->id}\">{$category->name}</option>";
                    });
                    ?>
                </select>
            </div>
            <br/>
            <button type="submit">Add product</button>
        </form>
    </div>
    <br/>
    <a href="{{ route('products.index') }}">Back to list products</a>
@endsection

resources/views/products/edit.blade.php
@extends('layout')
@section('title', 'Edit ' . $product->name)
@section('content')
    <h1>Update product</h1>
    <div class="row">
        <form method="post" enctype="multipart/form-data" action="{{ route('products.update', $product->id) }}">
            @method('PATCH')
            @csrf
            <div>
                <label for="name">Name:</label>
                <input maxlength=255 required="required" type="text" name="name" value={{ $product->name }} />
            </div>
            <div>
                <label for="image">Image:</label>
                <input type="file" name="image"/>
            </div>
            <div>
                <label for="description">Description:</label></br>
                <textarea maxlength=1000 cols=60 rows=13 required="required" type="text"
                          name="description">{{ $product->description }}</textarea>
            </div>
            <div>
                <label for="categories_ids">Categories:</label></br>
                <select multiple name="categories_ids[]">
                    <option selected disabled>Not modify</option>
                    <?php
                    use App\Category;
                    $categories = Category::all();
                    $categories->map(function ($category) {
                        echo "<option value=\"{$category->id}\">{$category->name}</option>";
                    });
                    ?>
                </select>
            </div>
            </br>
            <button type="submit">Update</button>
        </form>
    </div>
    <br/>
    <a href="{{ route('products.show', $product->id) }}">Back to product</a>
@endsection

resources/views/products/index.blade.php
@extends('layout')
@section('title', 'Main Page')
@section('user-info-additional')
    @guest
        <a href="{{ route('users.login') }}">Login</a>
    @endguest
    @role('admin')
    <a href="{{ route('products.create')}}">Add new product</a>
    @endrole
@endsection
<style>
    td a {
        display: block;
        padding: 6px;
    }

    td {
        text-align: center;
    }

    select {
        border: 1px;
        background: transparent;
        -webkit-appearance: none;
        -moz-appearance: none;
        appearance: none;
        background: none;
        padding: 5px;
        font-family: inherit;
    }

    .pagination li {
        display: inline-block;
    }

    .pagination li + li {
        margin-left: 1rem;
    }

    .pagination a {
        text-decoration: none;
        padding: 0.2rem 0.4rem;
        color: #000000;
        border: 1px solid #000000;
        border-radius: 2px;
    }
</style>
@section('content')
    <div class="row">
        <h1>Our products</h1>
        <table>
            <thead>
            <tr>
                <td>
                    <a href="{{ route('products.index', ['sortBy' => 'id']) }}">ID</a>
                </td>
                <td>
                    <a href="{{ route('products.index', ['sortBy' => 'name']) }}">Name</a>
                </td>
                <td>Description</td>
                <td>Image</td>
                <td>
                    <a href="{{ route('products.index', ['sortBy' => 'author_name']) }}">Author</a>
                </td>
                <td>
                    <a href="{{ route('products.index', ['sortBy' => 'feedbacks_count']) }}">Feedbacks</a>
                </td>
                <td>
                    <a href="{{ route('products.index', ['sortBy' => 'average_mark']) }}">Mark</a>
                </td>
                <td>Category</td>
            </tr>
            </thead>
            <tbody>
            @foreach($products as $product)
                <tr>
                    <td class="field">{{$product->id}}</td>
                    <td><a href="{{ route('products.show', $product->id) }}">{{ $product->name }}</a></td>
                    <td>{{ mb_substr($product->description, 0, 9) }}...</td>
                    <td><img height="32px" width="32px"
                             src="{{ asset('storage/' . $product->image_name) }}"></td>
                    <td>{{ $product->author_name }}</td>
                    <td>{{ $product->feedbacks_count }}</td>
                    <td>{{ round($product->average_mark, 1) }}</td>
                    <td>
                        <ul>
                            @foreach($product->categories as $category)
                                <li>{{ $category->name }}</li>
                            @endforeach
                        </ul>
                    </td>
                </tr>

            @endforeach
            </tbody>
        </table>
    </div>
    <form>
        <br/>Filter by category:
        @if (empty(Request::input('category_id')))
            <select name="category_id" onchange="this.form.submit()">
                <option selected disabled value=0>None</option>
                @foreach(App\Category::all() as $category)
                    <option value={{ $category->id }}> {{ $category->name }} </option>
                @endforeach
            </select>
        @else
            {{App\Category::findOrFail(Request::input('category_id'))->name}}
            <a href="{{ route('products.index') }}">Reset</a>
        @endif
    </form>
    <br/><br/>
    {{ $products->withQueryString()->render() }}
@endsection

resources/views/products/show.blade.php
@extends('layout')
@section('title', $product->name)
<style>
    .product-info {
        display: inline-block;
        margin-left: 5%;
        margin-right: 5%;
    }
</style>
@section('content')
    <h1>Detail Information</h1>
    <div class="product-info">
        <h2>{{ $product->name }}</h2>
        <p>
            <img height="190px" width="190px" src="{{ asset('storage/'. $product->image_name) }}" alt="Illustration"
                 align="left" vspace="5" hspace="5">
            {{ $product->description }}
        </p>
    </div>
    <br/>
    <div>
        <strong>Average mark:</strong> {{ round($product->feedbacks()->avg('mark'), 1) }}<br/>
        <strong>Author:</strong> {{ $product->author()->first()->login }}<br/>
        <strong>Categories:</strong><br/>
        {{ implode(', ', $product->categories->pluck('name')->all()) }}<br/>
        <br/>
        @guest
            <a href="{{ route('users.login') }}">Login</a><br/>
            <br/>
        @endguest
        @role('admin')
        <a href="{{ route('products.edit', $product->id) }}">Edit</a><br/>
        <br/>
        <form action="{{ route('products.destroy', $product->id) }}" method="post">
            @csrf
            @method('DELETE')
            <button type="submit">Delete</button>
        </form>
        <br/>
        @endrole
        <a href="{{ route('products.index') }}">Back to list products</a>
    </div>
    <div>
        <h3>Feedbacks</h3>
        @foreach($product->feedbacks as $feedback)
            <strong>{{ $feedback->author->login }}</strong> - mark: {{ $feedback->mark }}</br>
            Comment: {{ $feedback->description }}</br>
            </br>
        @endforeach
        <form method="post" action="{{ route('feedbacks.create') }}">
            @csrf
            <div>
                <label for="mark">Mark:</label>
                <input required="required" min="0" max="5" type="number" name="mark"/>
            </div>
            <div>
                <label for="description">Description:</label><br/>
                <input maxlength=400 required="required" type="text" name="description"/>
            </div>
            <input type="hidden" name="product_id" value="{{ $product->id }}"/>
            <br/>
            <button type="submit">Comment</button>
        </form>
    </div>
@endsection